/* tslint:disable */
/* eslint-disable */
/**
 * Coscine.Api.Search
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.7.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import { Configuration } from './configuration';
import globalAxios, { AxiosPromise, AxiosInstance } from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from './common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from './base';

/**
 * 
 * @export
 * @enum {string}
 */

export enum CategoryFilter {
    None = 'None',
    Resource = 'Resource',
    Project = 'Project',
    Metadata = 'Metadata'
}

/**
 * Item Search Result Object
 * @export
 * @interface ItemSearchResult
 */
export interface ItemSearchResult {
    /**
     * Graph Name
     * @type {string}
     * @memberof ItemSearchResult
     */
    graphName?: string;
    /**
     * Graph Name
     * @type {ItemType}
     * @memberof ItemSearchResult
     */
    type?: ItemType;
    /**
     * Search result fields
     * @type {any}
     * @memberof ItemSearchResult
     */
    source?: any | null;
}
/**
 * 
 * @export
 * @enum {string}
 */

export enum ItemType {
    Metadata = 'Metadata',
    Project = 'Project',
    Resource = 'Resource'
}

/**
 * 
 * @export
 * @enum {string}
 */

export enum OrderBy {
    DateCreatedAsc = 'Date_Created_Asc',
    DateCreatedDesc = 'Date_Created_Desc',
    ScoreAsc = 'Score_Asc',
    ScoreDesc = 'Score_Desc',
    NameAsc = 'Name_Asc',
    NameDesc = 'Name_Desc'
}


/**
 * SearchApi - axios parameter creator
 * @export
 */
export const SearchApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Search Elasticsearch
         * @param {string} [searchQuery] The actual search query
         * @param {boolean} [includeUsers] Specify user or only public metadata records could be found
         * @param {boolean} [useAdvancedSyntax] Set true for advanced Elasticsearch search syntax
         * @param {Array<string>} [includedLanguages] Set the used languages
         * @param {CategoryFilter} [categoryFilter] Set the category filter
         * @param {OrderBy} [orderBy] Set the order for sorting
         * @param {number} [pageNumber] The requested page number
         * @param {number} [pageSize] The size of a page
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchSearch: async (searchQuery?: string, includeUsers?: boolean, useAdvancedSyntax?: boolean, includedLanguages?: Array<string>, categoryFilter?: CategoryFilter, orderBy?: OrderBy, pageNumber?: number, pageSize?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Search`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (searchQuery !== undefined) {
                localVarQueryParameter['SearchQuery'] = searchQuery;
            }

            if (includeUsers !== undefined) {
                localVarQueryParameter['IncludeUsers'] = includeUsers;
            }

            if (useAdvancedSyntax !== undefined) {
                localVarQueryParameter['UseAdvancedSyntax'] = useAdvancedSyntax;
            }

            if (includedLanguages) {
                localVarQueryParameter['IncludedLanguages'] = includedLanguages;
            }

            if (categoryFilter !== undefined) {
                localVarQueryParameter['CategoryFilter'] = categoryFilter;
            }

            if (orderBy !== undefined) {
                localVarQueryParameter['OrderBy'] = orderBy;
            }

            if (pageNumber !== undefined) {
                localVarQueryParameter['PageNumber'] = pageNumber;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['PageSize'] = pageSize;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * SearchApi - functional programming interface
 * @export
 */
export const SearchApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = SearchApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Search Elasticsearch
         * @param {string} [searchQuery] The actual search query
         * @param {boolean} [includeUsers] Specify user or only public metadata records could be found
         * @param {boolean} [useAdvancedSyntax] Set true for advanced Elasticsearch search syntax
         * @param {Array<string>} [includedLanguages] Set the used languages
         * @param {CategoryFilter} [categoryFilter] Set the category filter
         * @param {OrderBy} [orderBy] Set the order for sorting
         * @param {number} [pageNumber] The requested page number
         * @param {number} [pageSize] The size of a page
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async searchSearch(searchQuery?: string, includeUsers?: boolean, useAdvancedSyntax?: boolean, includedLanguages?: Array<string>, categoryFilter?: CategoryFilter, orderBy?: OrderBy, pageNumber?: number, pageSize?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<ItemSearchResult>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.searchSearch(searchQuery, includeUsers, useAdvancedSyntax, includedLanguages, categoryFilter, orderBy, pageNumber, pageSize, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * SearchApi - factory interface
 * @export
 */
export const SearchApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = SearchApiFp(configuration)
    return {
        /**
         * 
         * @summary Search Elasticsearch
         * @param {string} [searchQuery] The actual search query
         * @param {boolean} [includeUsers] Specify user or only public metadata records could be found
         * @param {boolean} [useAdvancedSyntax] Set true for advanced Elasticsearch search syntax
         * @param {Array<string>} [includedLanguages] Set the used languages
         * @param {CategoryFilter} [categoryFilter] Set the category filter
         * @param {OrderBy} [orderBy] Set the order for sorting
         * @param {number} [pageNumber] The requested page number
         * @param {number} [pageSize] The size of a page
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchSearch(searchQuery?: string, includeUsers?: boolean, useAdvancedSyntax?: boolean, includedLanguages?: Array<string>, categoryFilter?: CategoryFilter, orderBy?: OrderBy, pageNumber?: number, pageSize?: number, options?: any): AxiosPromise<Array<ItemSearchResult>> {
            return localVarFp.searchSearch(searchQuery, includeUsers, useAdvancedSyntax, includedLanguages, categoryFilter, orderBy, pageNumber, pageSize, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * SearchApi - object-oriented interface
 * @export
 * @class SearchApi
 * @extends {BaseAPI}
 */
export class SearchApi extends BaseAPI {
    /**
     * 
     * @summary Search Elasticsearch
     * @param {string} [searchQuery] The actual search query
     * @param {boolean} [includeUsers] Specify user or only public metadata records could be found
     * @param {boolean} [useAdvancedSyntax] Set true for advanced Elasticsearch search syntax
     * @param {Array<string>} [includedLanguages] Set the used languages
     * @param {CategoryFilter} [categoryFilter] Set the category filter
     * @param {OrderBy} [orderBy] Set the order for sorting
     * @param {number} [pageNumber] The requested page number
     * @param {number} [pageSize] The size of a page
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SearchApi
     */
    public searchSearch(searchQuery?: string, includeUsers?: boolean, useAdvancedSyntax?: boolean, includedLanguages?: Array<string>, categoryFilter?: CategoryFilter, orderBy?: OrderBy, pageNumber?: number, pageSize?: number, options?: any) {
        return SearchApiFp(this.configuration).searchSearch(searchQuery, includeUsers, useAdvancedSyntax, includedLanguages, categoryFilter, orderBy, pageNumber, pageSize, options).then((request) => request(this.axios, this.basePath));
    }
}


